﻿using System.Windows.Forms;
using System.Numerics;
using SharpGL;
using System.Drawing;

namespace Graphics {
    class renderCam : camera2D {

        OpenGL gl;
        Control ownerControl;

        public Vector2 resolution {
            get { return new Vector2(ownerControl.Size.Width, ownerControl.Size.Height); }
        }

        public renderCam(OpenGL glContext, Control owner) : base() {
            gl = glContext;
            ownerControl = owner;
        }

        public void attacheMatrix() {
            gl.MultMatrix(mat);
        }

        public void drawTriangle(Vector2 corner01, Vector2 corner02, Vector2 corner03) {
            gl.Vertex(corner01);
            gl.Vertex(corner02);
            gl.Vertex(corner03);
        }

        public void drawQuad(Vector2 corner01, Vector2 corner02, Vector2 corner03, Vector2 corner04) {
            gl.Vertex(corner01);
            gl.Vertex(corner02);
            gl.Vertex(corner03);
            gl.Vertex(corner03);
            gl.Vertex(corner04);
            gl.Vertex(corner01);
        }

    }
}
